# SecretRecovery Class Reference

`#include <ida.h>`

Inheritance diagram for SecretRecovery:

List of all members.

## Detailed Description

a variant of Shamir's Secret Sharing Algorithm

Definition at line 78 of file ida.h.

## Public Member Functions
| SecretRecovery (int threshold, BufferedTransformation *attachment=NULL, bool removePadding=true)
void | IsolatedInitialize (const NameValuePairs &parameters=g_nullNameValuePairs)
unsigned int | GetThreshold () const
void | AddOutputChannel (word32 channelId)
void | ChannelData (word32 channelId, const byte *inString, size_t length, bool messageEnd)
lword | InputBuffered (word32 channelId) const
size_t | ChannelPut2 (const std::string &channel, const byte *begin, size_t length, int messageEnd, bool blocking)
void | SetAutoSignalPropagation (int propagation)
| set propagation of automatically generated and transferred signals
int | GetAutoSignalPropagation () const
bool | Flush (bool completeFlush, int propagation=-1, bool blocking=true)
| flush buffered input and/or output
bool | IsolatedFlush (bool hardFlush, bool blocking)
bool | ChannelFlush (const std::string &channel, bool hardFlush, int propagation=-1, bool blocking=true)
bool | MessageSeriesEnd (int propagation=-1, bool blocking=true)
| mark end of a series of messages
byte * | CreatePutSpace (size_t &size)
| request space which can be written into by the caller, and then used as input to Put()
size_t | Put2 (const byte *begin, size_t length, int messageEnd, bool blocking)
| input multiple bytes for blocking or non-blocking processing
size_t | PutModifiable2 (byte *inString, size_t length, int messageEnd, bool blocking)
| input multiple bytes that may be modified by callee for blocking or non-blocking processing
byte * | ChannelCreatePutSpace (const std::string &channel, size_t &size)
bool | ChannelPutModifiable (const std::string &channel, byte *inString, size_t length)
size_t | ChannelPutModifiable2 (const std::string &channel, byte *begin, size_t length, int messageEnd, bool blocking)
bool | Attachable ()
| returns whether this object allows attachment
BufferedTransformation * | AttachedTransformation ()
| returns the object immediately attached to this object or NULL for no attachment
const BufferedTransformation * | AttachedTransformation () const
void | Detach (BufferedTransformation *newAttachment=NULL)
| delete the current attachment chain and replace it with newAttachment
size_t | TransferTo2 (BufferedTransformation &target, lword &transferBytes, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true)
| upon return, byteCount contains number of bytes that have finished being transfered, and returns the number of bytes left in the current transfer block
size_t | CopyRangeTo2 (BufferedTransformation &target, lword &begin, lword end=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true) const
| upon return, begin contains the start position of data yet to be finished copying, and returns the number of bytes left in the current transfer block
void | Initialize (const NameValuePairs &parameters=g_nullNameValuePairs, int propagation=-1)
| initialize or reinitialize this object
BufferedTransformation & | Ref ()
| return a reference to this object
virtual std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
virtual Clonable * | Clone () const
| this is not implemented by most classes yet
bool | Wait (unsigned long milliseconds, CallStack const &callStack)
| wait on this object
CHANNELS
size_t | ChannelPutModifiable (const std::string &channel, byte *inString, size_t length, bool blocking=true)
size_t | ChannelPut (const std::string &channel, byte inByte, bool blocking=true)
size_t | ChannelPut (const std::string &channel, const byte *inString, size_t length, bool blocking=true)
size_t | ChannelPutWord16 (const std::string &channel, word16 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
size_t | ChannelPutWord32 (const std::string &channel, word32 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
bool | ChannelMessageEnd (const std::string &channel, int propagation=-1, bool blocking=true)
size_t | ChannelPutMessageEnd (const std::string &channel, const byte *inString, size_t length, int propagation=-1, bool blocking=true)
virtual bool | ChannelMessageSeriesEnd (const std::string &channel, int propagation=-1, bool blocking=true)
virtual void | SetRetrievalChannel (const std::string &channel)
INPUT
size_t | Put (byte inByte, bool blocking=true)
| input a byte for processing
size_t | Put (const byte *inString, size_t length, bool blocking=true)
| input multiple bytes
size_t | PutWord16 (word16 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| input a 16-bit word
size_t | PutWord32 (word32 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| input a 32-bit word
virtual bool | CanModifyInput () const
size_t | PutModifiable (byte *inString, size_t length, bool blocking=true)
| input multiple bytes that may be modified by callee
bool | MessageEnd (int propagation=-1, bool blocking=true)
size_t | PutMessageEnd (const byte *inString, size_t length, int propagation=-1, bool blocking=true)
WAITING
unsigned int | GetMaxWaitObjectCount () const
| maximum number of wait objects that this object can return
void | GetWaitObjects (WaitObjectContainer &container, CallStack const &callStack)
| put wait objects into container
SIGNALS
virtual bool | IsolatedMessageSeriesEnd (bool blocking)
RETRIEVAL OF ONE MESSAGE
virtual lword | MaxRetrievable () const
| returns number of bytes that is currently ready for retrieval
virtual bool | AnyRetrievable () const
| returns whether any bytes are currently ready for retrieval
virtual size_t | Get (byte &outByte)
| try to retrieve a single byte
virtual size_t | Get (byte *outString, size_t getMax)
| try to retrieve multiple bytes
virtual size_t | Peek (byte &outByte) const
| peek at the next byte without removing it from the output buffer
virtual size_t | Peek (byte *outString, size_t peekMax) const
| peek at multiple bytes without removing them from the output buffer
size_t | GetWord16 (word16 &value, ByteOrder order=BIG_ENDIAN_ORDER)
| try to retrieve a 16-bit word
size_t | GetWord32 (word32 &value, ByteOrder order=BIG_ENDIAN_ORDER)
| try to retrieve a 32-bit word
size_t | PeekWord16 (word16 &value, ByteOrder order=BIG_ENDIAN_ORDER) const
| try to peek at a 16-bit word
size_t | PeekWord32 (word32 &value, ByteOrder order=BIG_ENDIAN_ORDER) const
| try to peek at a 32-bit word
lword | TransferTo (BufferedTransformation &target, lword transferMax=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL)
| move transferMax bytes of the buffered output to target as input
virtual lword | Skip (lword skipMax=LWORD_MAX)
| discard skipMax bytes from the output buffer
lword | CopyTo (BufferedTransformation &target, lword copyMax=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL) const
| copy copyMax bytes of the buffered output to target as input
lword | CopyRangeTo (BufferedTransformation &target, lword position, lword copyMax=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL) const
| copy copyMax bytes of the buffered output, starting at position (relative to current position), to target as input
RETRIEVAL OF MULTIPLE MESSAGES
virtual lword | TotalBytesRetrievable () const
virtual unsigned int | NumberOfMessages () const
| number of times MessageEnd() has been received minus messages retrieved or skipped
virtual bool | AnyMessages () const
| returns true if NumberOfMessages() > 0
virtual bool | GetNextMessage ()
| start retrieving the next message
virtual unsigned int | SkipMessages (unsigned int count=UINT_MAX)
| skip count number of messages
unsigned int | TransferMessagesTo (BufferedTransformation &target, unsigned int count=UINT_MAX, const std::string &channel=DEFAULT_CHANNEL)
unsigned int | CopyMessagesTo (BufferedTransformation &target, unsigned int count=UINT_MAX, const std::string &channel=DEFAULT_CHANNEL) const
virtual void | SkipAll ()
void | TransferAllTo (BufferedTransformation &target, const std::string &channel=DEFAULT_CHANNEL)
void | CopyAllTo (BufferedTransformation &target, const std::string &channel=DEFAULT_CHANNEL) const
virtual bool | GetNextMessageSeries ()
virtual unsigned int | NumberOfMessagesInThisSeries () const
virtual unsigned int | NumberOfMessageSeries () const
NON-BLOCKING TRANSFER OF OUTPUT
size_t | TransferMessagesTo2 (BufferedTransformation &target, unsigned int &messageCount, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true)
| upon return, messageCount contains number of messages that have finished being transfered, and returns the number of bytes left in the current transfer block
size_t | TransferAllTo2 (BufferedTransformation &target, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true)
| returns the number of bytes left in the current transfer block
ATTACHMENT
virtual void | Attach (BufferedTransformation *newAttachment)
| add newAttachment to the end of attachment chain
## Static Public Attributes
static const std::string & | NULL_CHANNEL = DEFAULT_CHANNEL
## Protected Types
typedef std::map< word32, unsigned int > | InputChannelMap
## Protected Member Functions
void | FlushOutputQueues ()
void | OutputMessageEnds ()
unsigned int | InsertInputChannel (word32 channelId)
unsigned int | LookupInputChannel (word32 channelId) const
void | ComputeV (unsigned int)
void | PrepareInterpolation ()
void | ProcessInputQueues ()
virtual bool | InputBufferIsEmpty () const
virtual BufferedTransformation * | NewDefaultAttachment () const
void | Insert (Filter *nextFilter)
virtual bool | ShouldPropagateMessageEnd () const
virtual bool | ShouldPropagateMessageSeriesEnd () const
void | PropagateInitialize (const NameValuePairs &parameters, int propagation)
size_t | Output (int outputSite, const byte *inString, size_t length, int messageEnd, bool blocking, const std::string &channel=DEFAULT_CHANNEL)
size_t | OutputModifiable (int outputSite, byte *inString, size_t length, int messageEnd, bool blocking, const std::string &channel=DEFAULT_CHANNEL)
bool | OutputMessageEnd (int outputSite, int propagation, bool blocking, const std::string &channel=DEFAULT_CHANNEL)
bool | OutputFlush (int outputSite, bool hardFlush, int propagation, bool blocking, const std::string &channel=DEFAULT_CHANNEL)
bool | OutputMessageSeriesEnd (int outputSite, int propagation, bool blocking, const std::string &channel=DEFAULT_CHANNEL)
## Static Protected Member Functions
static int | DecrementPropagation (int propagation)
## Protected Attributes
bool | m_pad
InputChannelMap | m_inputChannelMap
InputChannelMap::iterator | m_lastMapPosition
std::vector< MessageQueue > | m_inputQueues
std::vector< word32 > | m_inputChannelIds
std::vector< word32 > | m_outputChannelIds
std::vector< word32 > | m_outputToInput
std::vector< std::string > | m_outputChannelIdStrings
std::vector< ByteQueue > | m_outputQueues
int | m_threshold
unsigned int | m_channelsReady
unsigned int | m_channelsFinished
std::vector< SecBlock< word32 > > | m_v
SecBlock< word32 > | m_u
SecBlock< word32 > | m_w
SecBlock< word32 > | m_y
size_t | m_inputPosition
int | m_continueAt

## Member Function Documentation

void AutoSignaling< Unflushable< Multichannel< Filter > > >::SetAutoSignalPropagation | ( | int | propagation | ) | `[inline, virtual, inherited]`

Reimplemented from BufferedTransformation.

Definition at line 157 of file simple.h.

bool Unflushable< Multichannel< Filter > >::Flush | ( | bool | hardFlush,
|  | int | propagation = `-1`,
|  | bool | blocking = `true` |
| ) |  |  | `[inline, virtual, inherited]`

Reimplemented from Multichannel< Filter >.

Definition at line 60 of file simple.h.

bool Multichannel< Filter >::MessageSeriesEnd | ( | int | propagation = `-1`,
|  | bool | blocking = `true` |
| ) |  |  | `[inline, virtual, inherited]`

Reimplemented from Filter.

Definition at line 127 of file simple.h.

byte* Multichannel< Filter >::CreatePutSpace | ( | size_t & | size | ) | `[inline, virtual, inherited]`

Reimplemented from BufferedTransformation.

Definition at line 129 of file simple.h.

size_t Multichannel< Filter >::Put2 | ( | const byte * | inString,
|  | size_t | length,
|  | int | messageEnd,
|  | bool | blocking |
| ) |  |  | `[inline, virtual, inherited]`

Implements BufferedTransformation.

Definition at line 131 of file simple.h.

size_t Multichannel< Filter >::PutModifiable2 | ( | byte * | inString,
|  | size_t | length,
|  | int | messageEnd,
|  | bool | blocking |
| ) |  |  | `[inline, virtual, inherited]`

Reimplemented from BufferedTransformation.

Definition at line 133 of file simple.h.

bool Filter::Attachable | ( |  | ) | `[inline, virtual, inherited]`

returns whether this object allows attachment

Some BufferedTransformation objects (e.g. Filter objects) allow other BufferedTransformation objects to be attached. When this is done, the first object instead of buffering its output, sents that output to the attached object as input. The entire attachment chain is deleted when the anchor object is destructed.

Reimplemented from BufferedTransformation.

Definition at line 20 of file filters.h.

BufferedTransformation& BufferedTransformation::Ref | ( |  | ) | `[inline, inherited]`

return a reference to this object

This function is useful for passing a temporary BufferedTransformation object to a function that takes a non-const reference.

Definition at line 793 of file cryptlib.h.

void BufferedTransformation::GetWaitObjects | ( | WaitObjectContainer & | container,
|  | CallStack const & | callStack |
| ) |  |  | `[virtual, inherited]`

put wait objects into container

Parameters:

  | callStack | is used for tracing no wait loops, example: something.GetWaitObjects(c, CallStack("my func after X", 0)); or in an outer GetWaitObjects() method that itself takes a callStack parameter: innerThing.GetWaitObjects(c, CallStack("MyClass::GetWaitObjects at X", &callStack));

Implements Waitable.

Reimplemented in Redirector, NetworkSource, and NetworkSink.

Definition at line 314 of file cryptlib.cpp.

References BufferedTransformation::AttachedTransformation(), and BufferedTransformation::GetWaitObjects().

Referenced by NetworkSource::GetWaitObjects(), and BufferedTransformation::GetWaitObjects().

lword BufferedTransformation::MaxRetrievable | ( |  | ) | const`[virtual, inherited]`

returns number of bytes that is currently ready for retrieval

All retrieval functions return the actual number of bytes retrieved, which is the lesser of the request number and MaxRetrievable().

Reimplemented in FileStore, RandomNumberStore, NullStore, MessageQueue, and ByteQueue.

Definition at line 379 of file cryptlib.cpp.

References BufferedTransformation::AttachedTransformation(), BufferedTransformation::CopyTo(), and BufferedTransformation::MaxRetrievable().

Referenced by RandomNumberStore::AnyRetrievable(), Integer::BERDecode(), and BufferedTransformation::MaxRetrievable().

bool BufferedTransformation::GetNextMessage | ( |  | ) | `[virtual, inherited]`

start retrieving the next message

Returns false if no more messages exist or this message is not completely retrieved.

Reimplemented in MessageQueue, and Store.

Definition at line 468 of file cryptlib.cpp.

References BufferedTransformation::AnyMessages(), BufferedTransformation::AttachedTransformation(), and BufferedTransformation::GetNextMessage().

Referenced by BufferedTransformation::GetNextMessage(), and BufferedTransformation::TransferMessagesTo2().

bool Waitable::Wait | ( | unsigned long | milliseconds,
|  | CallStack const & | callStack |
| ) |  |  | `[inherited]`

wait on this object

same as creating an empty container, calling GetWaitObjects(), and calling Wait() on the container

Definition at line 388 of file wait.cpp.

References Waitable::GetWaitObjects(), and WaitObjectContainer::Wait().

The documentation for this class was generated from the following file:

- ida.h